/*
 * IgnitionConfigUpdater.java
 *
 * Created on May 19, 2003, 11:59 PM
 */

package org.megaJoltLiteJr;

/**
 *
 * @author  brent
 */
import javax.comm.*;
import java.util.*;

import java.io.*;

public class IgnitionConfigUpdater extends BaseControllerCommunicator{

    public static final char READ_CONFIG_COMMAND='U';
    
    /** Creates a new instance of IgnitionConfigUpdater */
    public IgnitionConfigUpdater(SerialPort serialPort){
        super(serialPort);
    }
    
    public void writeFlash(){
        
        try{
            OutputStream out=super.getSerialOutputStream();
            //write flash command value
            out.write(87);
        }
        catch (IOException e){
            throw new CommRuntimeException("Unable to send read Request",e);
        }
        
    }
    
    public void updateIgnitionConfig(IgnitionConfig config){
        
        this.getInputBuffer().clear();
        
        
        try{
            OutputStream out=super.getSerialOutputStream();
            //update command value
            out.write(85);
            
            for (int index=0;index<IgnitionConfig.RPM_BIN_SIZE;index++){
               out.write(config.getRpmBinValue(index)); 
            }
            
            for (int index=0;index<IgnitionConfig.MAP_BIN_SIZE;index++){
                out.write(config.getMapBinValue(index));
            }
            
            for (int mapIndex=0;mapIndex<IgnitionConfig.MAP_BIN_SIZE;mapIndex++){
                for (int rpmIndex=0;rpmIndex<IgnitionConfig.RPM_BIN_SIZE;rpmIndex++){
                    out.write(config.getIgnitionMapValue(rpmIndex, mapIndex));
                }
            }
            
            out.write(config.getCylinderCount());
            
             int outputConfig = 0;
            
            for (int index=0;index<4;index++){
                if (config.getUserOutputType(index)==IgnitionConfig.USER_OUTPUT_TYPE_RPM) outputConfig |= (1 << index);
                if (config.getUserOutputMode(index)==IgnitionConfig.USER_OUTPUT_MODE_HIGH) outputConfig |= (1 << (index+4));
            }
            
            out.write(outputConfig);
            
            for (int index=0;index<IgnitionConfig.USER_OUTPUT_SIZE;index++){
                out.write(config.getUserOutputValue(index));
            }
            
            out.write(config.getRevLimitRpm());
            out.write(config.getShiftLightRpm());
            
        }
        catch (IOException e){
            throw new CommRuntimeException("Unable to send read Request",e);
        }
        
        super.releaseSerialPort();
        
    }
    
    
    public void dataReceived(java.util.List inBuffer) {}
    
}
